#include "DataOperators.h"

#include <QtDebug>

QDataStream& operator<<(QDataStream& out, const LaserData& data)
{
	out<<data.length;
	out<<data.fov;
	out<<data.resolution;
	for(int i=0; i<data.length; i++)
		out<<data.data[i];
		
	return out;
}
QDataStream& operator>>(QDataStream& out, LaserData& data)
{
	out>>data.length;
	out>>data.fov;
	out>>data.resolution;
	for(int i=0; i<data.length; i++)
		out>>data.data[i];
		
	return out;
}

QDataStream& operator<<(QDataStream& out, const LaserData3D& data)
{
	out<<data.height;
	out<<data.width;
	out<<data.vFov;
	out<<data.hFov;
	out<<data.vResolution;
	out<<data.hResolution;
	
	for(int i=0; i<data.height; i++)
		for(int j=0; j<data.width; j++)
			out<<data.data[i][j];
		
	return out;
}
QDataStream& operator>>(QDataStream& out, LaserData3D& data)
{
	out>>data.height;
	out>>data.width;
	out>>data.vFov;
	out>>data.hFov;
	out>>data.vResolution;
	out>>data.hResolution;
	
	for(int i=0; i<data.height; i++)
		for(int j=0; j<data.width; j++)
			out>>data.data[i][j];
		
	return out;
}


QDataStream& operator<<(QDataStream& out, const RFIDData& data)
{
	out<<data.ID;
	out<<data.dx;
	out<<data.dy;
	out<<data.dz;
		
	return out;
}
QDataStream& operator>>(QDataStream& out, RFIDData& data)
{
	out>>data.ID;
	out>>data.dx;
	out>>data.dy;
	out>>data.dz;
		
	return out;
}


QDataStream& operator<<(QDataStream& out, const StatusData& data)
{
	out<<data.battery;
	out<<data.intensity;
	out<<data.light;
	out<<data.time;
	out<<data.rotX;
	out<<data.rotY;
	out<<data.rotZ;
	out<<data.velX;
	out<<data.velY;
	out<<data.velZ;
	out<<data.x;
	out<<data.y;
	out<<data.z;
	
	return out;
}
QDataStream& operator>>(QDataStream& out, StatusData& data)
{
	out>>data.battery;
	out>>data.intensity;
	out>>data.light;
	out>>data.time;
	out>>data.rotX;
	out>>data.rotY;
	out>>data.rotZ;
	out>>data.velX;
	out>>data.velY;
	out>>data.velZ;
	out>>data.x;
	out>>data.y;
	out>>data.z;
	
	return out;
}

QDataStream& operator<<(QDataStream& out, const VictimRFIDData& data)
{
	out<<data.ID;
	out<<data.dx;
	out<<data.dy;
	out<<data.dz;
	
	switch(data.level)
	{
		case CANNOTSEE: 			out << (int)0; break;
		case CANSEE: 			out << (int)1; break;
		case CANSEEFALSEALARM: 	out << (int)2; break;
		case CANSEEVICTIM: 		out << (int)3; break;
		case CANSEEVICTIMSTATUS: 	out << (int)4; break;
	};
	
	out<<data.status;
	
	return out;
}
QDataStream& operator>>(QDataStream& out, VictimRFIDData& data)
{
	int level;
	
	out>>data.ID;
	out>>data.dx;
	out>>data.dy;
	out>>data.dz;
	out>>level;
	
	switch(level)
	{
		case 0: data.level = CANNOTSEE; break;
		case 1: data.level = CANSEE; break;
		case 2: data.level = CANSEEFALSEALARM; break;
		case 3: data.level = CANSEEVICTIM; break;
		case 4: data.level = CANSEEVICTIMSTATUS; break;
	};
	
	out>>data.status;
	
	return out;
}
