#ifndef HOUGHTRANSFORMER_H_
#define HOUGHTRANSFORMER_H_

#include <math.h>

#include <QList>

#include "ScanUtils.h"

class HoughTransformer
{
protected:

	static const float SQRT_2_INV;

	int** hits;
	float res;
	
	float* COS;
	float* SIN;
	int cacheLength;
	
	int width;
	int height;
	
	int radius;
	
	int threshold;
	
	void hit(int,int);
	void hit(int,int,int,int);
	
	void drawCircle(float, float);
	
	Point2 getMidPoint(int, int);
	
	void cacheSines(float, float, int);
	
	bool qualifies(int,int);
	
public:
	HoughTransformer(float, float, float);
	virtual ~HoughTransformer();
	
	void setRadius(float);
	
	QList< Point2 > getCircles(const LaserData&);
	
	void reset();
	
};

#endif /*HOUGHTRANSFORMER_H_*/
