#ifndef NAVIGATOR_H
#define NAVIGATOR_H

#include <QImage>
#include <QImageWriter>

#include "Agent.h"

#include "PositionActuator.h"

#include "SonarSensor.h"
#include "RFIDSensor.h"
#include "VictimRFIDSensor.h"

enum NavigationState {
    Exploring           = 0,
    GettingVictimID     = 1,
    GettingVictimStatus = 2
};

class Navigator {

private:

public:

	Navigator(PositionActuator*);
	virtual ~Navigator();

    virtual void process(SonarData sonar);
    virtual void process(VictimRFIDData rfid);
    virtual void process(RFIDData rfid) {}


private:

    virtual void navigate();

    PositionActuator* actor;

    double canGoN;
    double canGoNW;
    double canGoNNW;
    double canGoNE;
    double canGoNNE;

    double canGoW;
    double canGoE;

    double canGoSW;
    double canGoSE;
    double canGoS;

};

#endif
