#ifndef SINGLESTATESENSOR_H_
#define SINGLESTATESENSOR_H_

#include <QMutex>
#include <QMutexLocker>

#include "Sensor.h"

template< typename T >
class SingleStateSensor : public Sensor
{

public:

    SingleStateSensor(QString type, QString name) : Sensor(type, name) {}
	virtual ~SingleStateSensor() {}

	T getData() {
		QMutexLocker lock(&mxdata);
		return data;
	}

protected:

	T data;
	QMutex mxdata;

};

#endif
