#include "LaserDevice.h"

#include <QDebug>

const QString LaserDevice::LASER("RangeScanner");

LaserDevice::LaserDevice(QString name)
	: QueueDevice<LaserData>(name, LASER)
{
}

LaserDevice::~LaserDevice()
{
}

void LaserDevice::process(QMap< QString, QString > *data) {
	LaserData newData;
	newData.fov = (*data)["FOV"].toDouble();
	newData.resolution = (*data)["Resolution"].toDouble();
	
	QStringList ranges = (*data)["Range"].split(",");
	newData.length = ranges.count();
	newData.data = new double[newData.length];
	
	for(int i=0; i<newData.length; i++) {
		newData.data[i] = ranges[i].toDouble();
	}
	
	enqueueData(newData);
}

bool LaserDevice::acceptsMsg(QString type) {
	return type == "SEN";
}
