#include "RFIDSensor.h"
#include "Agent.h"

#include <iostream>
#include <QDebug>
#include <QStringList>


const QString RFIDSensor::RFID = "RFID";



RFIDSensor::RFIDSensor(QString name)
: SingleStateSensor< QMap<QString, RFIDData> >(RFIDSensor::RFID, name)
{
	// RFID doesnt supply config
}

RFIDSensor::~RFIDSensor()
{
}


void RFIDSensor::accept(QMap<QString, QString>* msg) {
	this->data.clear();
	{
		{
			QMutexLocker lock(&this->mxdata);

			QList<QString> IDs = msg->values("ID");
			QList<QString> Locs = msg->values("Location");
			
			for(int i=0; i<IDs.size(); i++)
			{
				RFIDData tag;
				tag.ID = IDs[i];
				
				QStringList list = Locs[i].split(",");
				tag.dx = list[0].toDouble();
				tag.dy = list[1].toDouble();
				tag.dz = list[2].toDouble();

				this->data.insert(tag.ID, tag);
			}
		}

		this->agent->notifyUpdate(this);
	}
}


