#include <QtDebug>

#include "LaserData.h"
#include "HoughTransformer.h"


LaserData range;
QString actual;

void initAlmostHit();
void initCloseHit();
void initHit();

int main(int argc, char** argv)
{
	initHit();
	
	HoughTransformer trans(30.0, 15.0, .05);
	
	QList<Point2> hits = trans.getCircles(range);
	
	for(int i=0; i<hits.size(); i++)
	{
		qDebug() << "circ at " << hits[i].x << hits[i].y;
	}
	
	qDebug() << actual;
}
void initHit()
{
	actual = "actually at: 2.29,-0.62,-0.83";
	range.length= 361 ; 
range.fov= 3.1415 ; 
range.resolution= 0.0087 ; 
range.maxRange= 15 ; 
range.minRange= 0.01 ; 
range.data = new double[ 361 ]; 
range.data[ 0 ]= 3.9334 ; 
range.data[ 1 ]= 3.9576 ; 
range.data[ 2 ]= 3.9756 ; 
range.data[ 3 ]= 3.991 ; 
range.data[ 4 ]= 4.0093 ; 
range.data[ 5 ]= 4.0302 ; 
range.data[ 6 ]= 4.0452 ; 
range.data[ 7 ]= 4.0704 ; 
range.data[ 8 ]= 4.0842 ; 
range.data[ 9 ]= 4.1009 ; 
range.data[ 10 ]= 4.064 ; 
range.data[ 11 ]= 4.004 ; 
range.data[ 12 ]= 3.9545 ; 
range.data[ 13 ]= 3.8963 ; 
range.data[ 14 ]= 3.8436 ; 
range.data[ 15 ]= 3.7929 ; 
range.data[ 16 ]= 3.7265 ; 
range.data[ 17 ]= 3.6786 ; 
range.data[ 18 ]= 3.6292 ; 
range.data[ 19 ]= 3.5787 ; 
range.data[ 20 ]= 3.5408 ; 
range.data[ 21 ]= 3.4957 ; 
range.data[ 22 ]= 3.4514 ; 
range.data[ 23 ]= 3.4101 ; 
range.data[ 24 ]= 3.3756 ; 
range.data[ 25 ]= 3.3316 ; 
range.data[ 26 ]= 3.2875 ; 
range.data[ 27 ]= 3.3094 ; 
range.data[ 28 ]= 0.6105 ; 
range.data[ 29 ]= 0.6098 ; 
range.data[ 30 ]= 0.6088 ; 
range.data[ 31 ]= 0.6085 ; 
range.data[ 32 ]= 0.8253 ; 
range.data[ 33 ]= 0.9933 ; 
range.data[ 34 ]= 1.2523 ; 
range.data[ 35 ]= 1.5922 ; 
range.data[ 36 ]= 1.6126 ; 
range.data[ 37 ]= 1.6372 ; 
range.data[ 38 ]= 1.6522 ; 
range.data[ 39 ]= 1.669 ; 
range.data[ 40 ]= 1.6841 ; 
range.data[ 41 ]= 1.699 ; 
range.data[ 42 ]= 1.7163 ; 
range.data[ 43 ]= 1.7319 ; 
range.data[ 44 ]= 1.7491 ; 
range.data[ 45 ]= 1.7662 ; 
range.data[ 46 ]= 1.786 ; 
range.data[ 47 ]= 1.8044 ; 
range.data[ 48 ]= 1.8258 ; 
range.data[ 49 ]= 1.8434 ; 
range.data[ 50 ]= 1.8658 ; 
range.data[ 51 ]= 1.8882 ; 
range.data[ 52 ]= 1.9071 ; 
range.data[ 53 ]= 1.9279 ; 
range.data[ 54 ]= 1.9522 ; 
range.data[ 55 ]= 1.9767 ; 
range.data[ 56 ]= 2.0006 ; 
range.data[ 57 ]= 2.0264 ; 
range.data[ 58 ]= 2.0519 ; 
range.data[ 59 ]= 2.0796 ; 
range.data[ 60 ]= 2.1069 ; 
range.data[ 61 ]= 2.1339 ; 
range.data[ 62 ]= 2.1643 ; 
range.data[ 63 ]= 2.196 ; 
range.data[ 64 ]= 2.2269 ; 
range.data[ 65 ]= 2.2587 ; 
range.data[ 66 ]= 2.2949 ; 
range.data[ 67 ]= 2.3288 ; 
range.data[ 68 ]= 2.3599 ; 
range.data[ 69 ]= 2.4028 ; 
range.data[ 70 ]= 2.4387 ; 
range.data[ 71 ]= 2.4782 ; 
range.data[ 72 ]= 2.5191 ; 
range.data[ 73 ]= 2.5656 ; 
range.data[ 74 ]= 2.6081 ; 
range.data[ 75 ]= 2.6552 ; 
range.data[ 76 ]= 2.702 ; 
range.data[ 77 ]= 2.751 ; 
range.data[ 78 ]= 2.807 ; 
range.data[ 79 ]= 2.8573 ; 
range.data[ 80 ]= 2.9191 ; 
range.data[ 81 ]= 2.9759 ; 
range.data[ 82 ]= 3.0403 ; 
range.data[ 83 ]= 3.1091 ; 
range.data[ 84 ]= 3.1706 ; 
range.data[ 85 ]= 3.2458 ; 
range.data[ 86 ]= 3.2563 ; 
range.data[ 87 ]= 3.2507 ; 
range.data[ 88 ]= 3.2351 ; 
range.data[ 89 ]= 3.2287 ; 
range.data[ 90 ]= 3.2137 ; 
range.data[ 91 ]= 3.208 ; 
range.data[ 92 ]= 3.1946 ; 
range.data[ 93 ]= 3.185 ; 
range.data[ 94 ]= 3.1757 ; 
range.data[ 95 ]= 3.1713 ; 
range.data[ 96 ]= 3.1609 ; 
range.data[ 97 ]= 3.1533 ; 
range.data[ 98 ]= 3.1456 ; 
range.data[ 99 ]= 3.1408 ; 
range.data[ 100 ]= 3.1318 ; 
range.data[ 101 ]= 1.1 ; 
range.data[ 102 ]= 1.0972 ; 
range.data[ 103 ]= 1.0989 ; 
range.data[ 104 ]= 1.1858 ; 
range.data[ 105 ]= 1.2385 ; 
range.data[ 106 ]= 1.2996 ; 
range.data[ 107 ]= 1.3621 ; 
range.data[ 108 ]= 1.4268 ; 
range.data[ 109 ]= 1.5053 ; 
range.data[ 110 ]= 1.5968 ; 
range.data[ 111 ]= 1.6936 ; 
range.data[ 112 ]= 1.7914 ; 
range.data[ 113 ]= 1.9184 ; 
range.data[ 114 ]= 2.0515 ; 
range.data[ 115 ]= 2.2197 ; 
range.data[ 116 ]= 2.3863 ; 
range.data[ 117 ]= 2.6153 ; 
range.data[ 118 ]= 2.8788 ; 
range.data[ 119 ]= 3.0465 ; 
range.data[ 120 ]= 3.0433 ; 
range.data[ 121 ]= 3.0424 ; 
range.data[ 122 ]= 3.0366 ; 
range.data[ 123 ]= 3.0364 ; 
range.data[ 124 ]= 3.0336 ; 
range.data[ 125 ]= 3.0367 ; 
range.data[ 126 ]= 3.0332 ; 
range.data[ 127 ]= 3.0348 ; 
range.data[ 128 ]= 3.0321 ; 
range.data[ 129 ]= 3.0335 ; 
range.data[ 130 ]= 3.0353 ; 
range.data[ 131 ]= 3.0313 ; 
range.data[ 132 ]= 3.0352 ; 
range.data[ 133 ]= 3.0381 ; 
range.data[ 134 ]= 2.4038 ; 
range.data[ 135 ]= 2.3345 ; 
range.data[ 136 ]= 2.2962 ; 
range.data[ 137 ]= 2.2624 ; 
range.data[ 138 ]= 2.24 ; 
range.data[ 139 ]= 2.2197 ; 
range.data[ 140 ]= 2.2021 ; 
range.data[ 141 ]= 2.186 ; 
range.data[ 142 ]= 2.1724 ; 
range.data[ 143 ]= 2.1618 ; 
range.data[ 144 ]= 2.1553 ; 
range.data[ 145 ]= 2.1485 ; 
range.data[ 146 ]= 2.1385 ; 
range.data[ 147 ]= 2.1355 ; 
range.data[ 148 ]= 2.1323 ; 
range.data[ 149 ]= 2.1294 ; 
range.data[ 150 ]= 2.1267 ; 
range.data[ 151 ]= 2.1261 ; 
range.data[ 152 ]= 2.1266 ; 
range.data[ 153 ]= 2.1297 ; 
range.data[ 154 ]= 2.1297 ; 
range.data[ 155 ]= 2.1347 ; 
range.data[ 156 ]= 2.1382 ; 
range.data[ 157 ]= 2.147 ; 
range.data[ 158 ]= 2.151 ; 
range.data[ 159 ]= 2.1617 ; 
range.data[ 160 ]= 2.1702 ; 
range.data[ 161 ]= 2.1857 ; 
range.data[ 162 ]= 2.1987 ; 
range.data[ 163 ]= 2.2153 ; 
range.data[ 164 ]= 2.2366 ; 
range.data[ 165 ]= 2.2613 ; 
range.data[ 166 ]= 2.2889 ; 
range.data[ 167 ]= 2.3302 ; 
range.data[ 168 ]= 2.3885 ; 
range.data[ 169 ]= 3.2396 ; 
range.data[ 170 ]= 3.2526 ; 
range.data[ 171 ]= 3.2634 ; 
range.data[ 172 ]= 3.2714 ; 
range.data[ 173 ]= 3.2833 ; 
range.data[ 174 ]= 3.2993 ; 
range.data[ 175 ]= 3.3088 ; 
range.data[ 176 ]= 3.3241 ; 
range.data[ 177 ]= 3.3365 ; 
range.data[ 178 ]= 3.3474 ; 
range.data[ 179 ]= 3.3663 ; 
range.data[ 180 ]= 3.3786 ; 
range.data[ 181 ]= 3.3908 ; 
range.data[ 182 ]= 3.4098 ; 
range.data[ 183 ]= 3.4237 ; 
range.data[ 184 ]= 3.4357 ; 
range.data[ 185 ]= 3.4553 ; 
range.data[ 186 ]= 3.4749 ; 
range.data[ 187 ]= 3.4905 ; 
range.data[ 188 ]= 3.5099 ; 
range.data[ 189 ]= 3.5261 ; 
range.data[ 190 ]= 3.5433 ; 
range.data[ 191 ]= 3.5641 ; 
range.data[ 192 ]= 3.5804 ; 
range.data[ 193 ]= 3.6049 ; 
range.data[ 194 ]= 3.6248 ; 
range.data[ 195 ]= 3.6409 ; 
range.data[ 196 ]= 3.6647 ; 
range.data[ 197 ]= 3.6831 ; 
range.data[ 198 ]= 3.7143 ; 
range.data[ 199 ]= 3.7313 ; 
range.data[ 200 ]= 3.7439 ; 
range.data[ 201 ]= 3.7832 ; 
range.data[ 202 ]= 3.8057 ; 
range.data[ 203 ]= 3.8293 ; 
range.data[ 204 ]= 3.8566 ; 
range.data[ 205 ]= 3.884 ; 
range.data[ 206 ]= 3.9109 ; 
range.data[ 207 ]= 3.9423 ; 
range.data[ 208 ]= 2.913 ; 
range.data[ 209 ]= 2.8932 ; 
range.data[ 210 ]= 2.8698 ; 
range.data[ 211 ]= 2.841 ; 
range.data[ 212 ]= 2.8163 ; 
range.data[ 213 ]= 2.7929 ; 
range.data[ 214 ]= 2.7693 ; 
range.data[ 215 ]= 2.7452 ; 
range.data[ 216 ]= 2.7213 ; 
range.data[ 217 ]= 2.7019 ; 
range.data[ 218 ]= 2.6797 ; 
range.data[ 219 ]= 2.6541 ; 
range.data[ 220 ]= 2.6366 ; 
range.data[ 221 ]= 2.6164 ; 
range.data[ 222 ]= 2.5997 ; 
range.data[ 223 ]= 2.5772 ; 
range.data[ 224 ]= 2.5569 ; 
range.data[ 225 ]= 2.5396 ; 
range.data[ 226 ]= 2.5223 ; 
range.data[ 227 ]= 2.5078 ; 
range.data[ 228 ]= 2.489 ; 
range.data[ 229 ]= 2.4745 ; 
range.data[ 230 ]= 2.4585 ; 
range.data[ 231 ]= 2.4424 ; 
range.data[ 232 ]= 2.4268 ; 
range.data[ 233 ]= 2.4135 ; 
range.data[ 234 ]= 2.3988 ; 
range.data[ 235 ]= 2.3821 ; 
range.data[ 236 ]= 2.3686 ; 
range.data[ 237 ]= 2.3523 ; 
range.data[ 238 ]= 2.343 ; 
range.data[ 239 ]= 2.3295 ; 
range.data[ 240 ]= 2.3184 ; 
range.data[ 241 ]= 2.2947 ; 
range.data[ 242 ]= 2.2931 ; 
range.data[ 243 ]= 2.288 ; 
range.data[ 244 ]= 2.2863 ; 
range.data[ 245 ]= 2.2795 ; 
range.data[ 246 ]= 2.276 ; 
range.data[ 247 ]= 2.2692 ; 
range.data[ 248 ]= 2.2673 ; 
range.data[ 249 ]= 2.2631 ; 
range.data[ 250 ]= 2.2561 ; 
range.data[ 251 ]= 2.2551 ; 
range.data[ 252 ]= 2.2486 ; 
range.data[ 253 ]= 2.2443 ; 
range.data[ 254 ]= 2.2417 ; 
range.data[ 255 ]= 2.2411 ; 
range.data[ 256 ]= 2.2392 ; 
range.data[ 257 ]= 2.2343 ; 
range.data[ 258 ]= 2.2302 ; 
range.data[ 259 ]= 2.2276 ; 
range.data[ 260 ]= 2.2264 ; 
range.data[ 261 ]= 2.2272 ; 
range.data[ 262 ]= 2.2219 ; 
range.data[ 263 ]= 2.2198 ; 
range.data[ 264 ]= 2.2188 ; 
range.data[ 265 ]= 2.2205 ; 
range.data[ 266 ]= 2.2168 ; 
range.data[ 267 ]= 2.217 ; 
range.data[ 268 ]= 2.215 ; 
range.data[ 269 ]= 2.2148 ; 
range.data[ 270 ]= 2.2154 ; 
range.data[ 271 ]= 2.2171 ; 
range.data[ 272 ]= 2.2276 ; 
range.data[ 273 ]= 2.2375 ; 
range.data[ 274 ]= 2.2523 ; 
range.data[ 275 ]= 2.2628 ; 
range.data[ 276 ]= 2.2725 ; 
range.data[ 277 ]= 2.2869 ; 
range.data[ 278 ]= 2.2972 ; 
range.data[ 279 ]= 2.3124 ; 
range.data[ 280 ]= 2.3245 ; 
range.data[ 281 ]= 2.3403 ; 
range.data[ 282 ]= 2.3511 ; 
range.data[ 283 ]= 2.3662 ; 
range.data[ 284 ]= 2.3809 ; 
range.data[ 285 ]= 2.3981 ; 
range.data[ 286 ]= 2.4108 ; 
range.data[ 287 ]= 2.4297 ; 
range.data[ 288 ]= 2.4465 ; 
range.data[ 289 ]= 2.4603 ; 
range.data[ 290 ]= 2.4801 ; 
range.data[ 291 ]= 2.4957 ; 
range.data[ 292 ]= 2.5128 ; 
range.data[ 293 ]= 2.5317 ; 
range.data[ 294 ]= 2.5502 ; 
range.data[ 295 ]= 2.6078 ; 
range.data[ 296 ]= 2.6665 ; 
range.data[ 297 ]= 2.7312 ; 
range.data[ 298 ]= 2.8008 ; 
range.data[ 299 ]= 2.8706 ; 
range.data[ 300 ]= 2.9404 ; 
range.data[ 301 ]= 3.0223 ; 
range.data[ 302 ]= 3.104 ; 
range.data[ 303 ]= 3.5103 ; 
range.data[ 304 ]= 3.1438 ; 
range.data[ 305 ]= 3.1466 ; 
range.data[ 306 ]= 3.1432 ; 
range.data[ 307 ]= 3.1429 ; 
range.data[ 308 ]= 3.1452 ; 
range.data[ 309 ]= 3.141 ; 
range.data[ 310 ]= 3.1431 ; 
range.data[ 311 ]= 3.1437 ; 
range.data[ 312 ]= 3.1429 ; 
range.data[ 313 ]= 3.1438 ; 
range.data[ 314 ]= 3.1476 ; 
range.data[ 315 ]= 3.1482 ; 
range.data[ 316 ]= 3.1513 ; 
range.data[ 317 ]= 3.1487 ; 
range.data[ 318 ]= 3.154 ; 
range.data[ 319 ]= 3.1593 ; 
range.data[ 320 ]= 3.158 ; 
range.data[ 321 ]= 3.1633 ; 
range.data[ 322 ]= 3.1668 ; 
range.data[ 323 ]= 3.456 ; 
range.data[ 324 ]= 3.4612 ; 
range.data[ 325 ]= 3.4679 ; 
range.data[ 326 ]= 3.4686 ; 
range.data[ 327 ]= 3.474 ; 
range.data[ 328 ]= 3.4802 ; 
range.data[ 329 ]= 3.4873 ; 
range.data[ 330 ]= 3.4942 ; 
range.data[ 331 ]= 3.4986 ; 
range.data[ 332 ]= 3.5083 ; 
range.data[ 333 ]= 3.5099 ; 
range.data[ 334 ]= 3.5227 ; 
range.data[ 335 ]= 3.5256 ; 
range.data[ 336 ]= 3.2396 ; 
range.data[ 337 ]= 3.2422 ; 
range.data[ 338 ]= 3.2513 ; 
range.data[ 339 ]= 3.2602 ; 
range.data[ 340 ]= 3.2649 ; 
range.data[ 341 ]= 3.2765 ; 
range.data[ 342 ]= 3.285 ; 
range.data[ 343 ]= 3.2968 ; 
range.data[ 344 ]= 3.3007 ; 
range.data[ 345 ]= 3.3155 ; 
range.data[ 346 ]= 3.3237 ; 
range.data[ 347 ]= 3.3345 ; 
range.data[ 348 ]= 3.3446 ; 
range.data[ 349 ]= 3.3555 ; 
range.data[ 350 ]= 3.3678 ; 
range.data[ 351 ]= 3.3802 ; 
range.data[ 352 ]= 3.3919 ; 
range.data[ 353 ]= 3.399 ; 
range.data[ 354 ]= 3.4105 ; 
range.data[ 355 ]= 4.3769 ; 
range.data[ 356 ]= 4.291 ; 
range.data[ 357 ]= 1.8264 ; 
range.data[ 358 ]= 1.8308 ; 
range.data[ 359 ]= 1.8119 ; 
range.data[ 360 ]= 1.7812 ; 
}
void initCloseHit()
{
	actual = "unknown";
	range.length= 361 ; 
range.fov= 3.1415 ; 
range.resolution= 0.0087 ; 
range.maxRange= 15 ; 
range.minRange= 0.01 ; 
range.data = new double[ 361 ]; 
range.data[ 0 ]= 1.9044 ; 
range.data[ 1 ]= 1.9357 ; 
range.data[ 2 ]= 1.9648 ; 
range.data[ 3 ]= 1.9967 ; 
range.data[ 4 ]= 2.0293 ; 
range.data[ 5 ]= 2.0626 ; 
range.data[ 6 ]= 2.1008 ; 
range.data[ 7 ]= 2.1363 ; 
range.data[ 8 ]= 2.1738 ; 
range.data[ 9 ]= 2.2136 ; 
range.data[ 10 ]= 2.2526 ; 
range.data[ 11 ]= 2.2985 ; 
range.data[ 12 ]= 2.3411 ; 
range.data[ 13 ]= 2.3924 ; 
range.data[ 14 ]= 2.4374 ; 
range.data[ 15 ]= 2.4894 ; 
range.data[ 16 ]= 2.5428 ; 
range.data[ 17 ]= 2.5967 ; 
range.data[ 18 ]= 2.6575 ; 
range.data[ 19 ]= 2.722 ; 
range.data[ 20 ]= 2.7804 ; 
range.data[ 21 ]= 2.853 ; 
range.data[ 22 ]= 2.92 ; 
range.data[ 23 ]= 2.9946 ; 
range.data[ 24 ]= 3.0734 ; 
range.data[ 25 ]= 3.1081 ; 
range.data[ 26 ]= 3.1008 ; 
range.data[ 27 ]= 3.0929 ; 
range.data[ 28 ]= 3.0868 ; 
range.data[ 29 ]= 3.0763 ; 
range.data[ 30 ]= 3.0673 ; 
range.data[ 31 ]= 3.059 ; 
range.data[ 32 ]= 3.0545 ; 
range.data[ 33 ]= 3.0444 ; 
range.data[ 34 ]= 3.0402 ; 
range.data[ 35 ]= 3.0347 ; 
range.data[ 36 ]= 3.0271 ; 
range.data[ 37 ]= 3.0182 ; 
range.data[ 38 ]= 3.013 ; 
range.data[ 39 ]= 3.0106 ; 
range.data[ 40 ]= 3.0049 ; 
range.data[ 41 ]= 2.9968 ; 
range.data[ 42 ]= 2.9944 ; 
range.data[ 43 ]= 2.9922 ; 
range.data[ 44 ]= 2.9841 ; 
range.data[ 45 ]= 2.9843 ; 
range.data[ 46 ]= 2.9793 ; 
range.data[ 47 ]= 2.9744 ; 
range.data[ 48 ]= 2.9718 ; 
range.data[ 49 ]= 2.9659 ; 
range.data[ 50 ]= 2.9654 ; 
range.data[ 51 ]= 2.9615 ; 
range.data[ 52 ]= 2.9604 ; 
range.data[ 53 ]= 2.9602 ; 
range.data[ 54 ]= 0.984 ; 
range.data[ 55 ]= 0.985 ; 
range.data[ 56 ]= 0.9834 ; 
range.data[ 57 ]= 1.2765 ; 
range.data[ 58 ]= 1.6651 ; 
range.data[ 59 ]= 2.3673 ; 
range.data[ 60 ]= 2.9506 ; 
range.data[ 61 ]= 2.9527 ; 
range.data[ 62 ]= 2.9479 ; 
range.data[ 63 ]= 2.95 ; 
range.data[ 64 ]= 2.95 ; 
range.data[ 65 ]= 2.9527 ; 
range.data[ 66 ]= 2.9511 ; 
range.data[ 67 ]= 2.9512 ; 
range.data[ 68 ]= 2.9532 ; 
range.data[ 69 ]= 2.9547 ; 
range.data[ 70 ]= 2.9559 ; 
range.data[ 71 ]= 2.9595 ; 
range.data[ 72 ]= 2.9606 ; 
range.data[ 73 ]= 2.9658 ; 
range.data[ 74 ]= 2.9677 ; 
range.data[ 75 ]= 2.9682 ; 
range.data[ 76 ]= 2.9719 ; 
range.data[ 77 ]= 2.9752 ; 
range.data[ 78 ]= 2.3255 ; 
range.data[ 79 ]= 2.2796 ; 
range.data[ 80 ]= 2.2449 ; 
range.data[ 81 ]= 2.217 ; 
range.data[ 82 ]= 2.1957 ; 
range.data[ 83 ]= 2.1795 ; 
range.data[ 84 ]= 2.1652 ; 
range.data[ 85 ]= 2.1489 ; 
range.data[ 86 ]= 2.1365 ; 
range.data[ 87 ]= 2.1278 ; 
range.data[ 88 ]= 2.1207 ; 
range.data[ 89 ]= 2.1138 ; 
range.data[ 90 ]= 2.1079 ; 
range.data[ 91 ]= 2.1028 ; 
range.data[ 92 ]= 2.098 ; 
range.data[ 93 ]= 2.0974 ; 
range.data[ 94 ]= 2.098 ; 
range.data[ 95 ]= 2.0949 ; 
range.data[ 96 ]= 2.0986 ; 
range.data[ 97 ]= 2.1008 ; 
range.data[ 98 ]= 2.1006 ; 
range.data[ 99 ]= 2.1082 ; 
range.data[ 100 ]= 2.1129 ; 
range.data[ 101 ]= 2.116 ; 
range.data[ 102 ]= 2.126 ; 
range.data[ 103 ]= 2.1342 ; 
range.data[ 104 ]= 2.1474 ; 
range.data[ 105 ]= 2.1605 ; 
range.data[ 106 ]= 2.1747 ; 
range.data[ 107 ]= 2.1917 ; 
range.data[ 108 ]= 2.2137 ; 
range.data[ 109 ]= 2.2386 ; 
range.data[ 110 ]= 2.2693 ; 
range.data[ 111 ]= 2.3101 ; 
range.data[ 112 ]= 2.3771 ; 
range.data[ 113 ]= 3.2803 ; 
range.data[ 114 ]= 3.2942 ; 
range.data[ 115 ]= 3.309 ; 
range.data[ 116 ]= 3.3242 ; 
range.data[ 117 ]= 3.3386 ; 
range.data[ 118 ]= 3.3561 ; 
range.data[ 119 ]= 3.3711 ; 
range.data[ 120 ]= 3.3921 ; 
range.data[ 121 ]= 3.4094 ; 
range.data[ 122 ]= 3.4265 ; 
range.data[ 123 ]= 3.4446 ; 
range.data[ 124 ]= 3.4597 ; 
range.data[ 125 ]= 3.4797 ; 
range.data[ 126 ]= 3.4985 ; 
range.data[ 127 ]= 3.5245 ; 
range.data[ 128 ]= 3.5394 ; 
range.data[ 129 ]= 3.5642 ; 
range.data[ 130 ]= 3.5832 ; 
range.data[ 131 ]= 3.6031 ; 
range.data[ 132 ]= 3.6256 ; 
range.data[ 133 ]= 3.648 ; 
range.data[ 134 ]= 3.6731 ; 
range.data[ 135 ]= 3.6988 ; 
range.data[ 136 ]= 3.7204 ; 
range.data[ 137 ]= 3.7511 ; 
range.data[ 138 ]= 3.7732 ; 
range.data[ 139 ]= 3.8055 ; 
range.data[ 140 ]= 3.8151 ; 
range.data[ 141 ]= 3.858 ; 
range.data[ 142 ]= 3.8892 ; 
range.data[ 143 ]= 3.9161 ; 
range.data[ 144 ]= 3.947 ; 
range.data[ 145 ]= 3.9791 ; 
range.data[ 146 ]= 4.0107 ; 
range.data[ 147 ]= 4.0461 ; 
range.data[ 148 ]= 4.0781 ; 
range.data[ 149 ]= 2.9938 ; 
range.data[ 150 ]= 2.9853 ; 
range.data[ 151 ]= 2.9582 ; 
range.data[ 152 ]= 2.9352 ; 
range.data[ 153 ]= 2.912 ; 
range.data[ 154 ]= 2.8938 ; 
range.data[ 155 ]= 2.8672 ; 
range.data[ 156 ]= 2.8499 ; 
range.data[ 157 ]= 2.8285 ; 
range.data[ 158 ]= 2.8058 ; 
range.data[ 159 ]= 2.7878 ; 
range.data[ 160 ]= 2.77 ; 
range.data[ 161 ]= 2.7496 ; 
range.data[ 162 ]= 2.7354 ; 
range.data[ 163 ]= 2.7152 ; 
range.data[ 164 ]= 2.6952 ; 
range.data[ 165 ]= 2.6801 ; 
range.data[ 166 ]= 2.6649 ; 
range.data[ 167 ]= 2.6481 ; 
range.data[ 168 ]= 2.6337 ; 
range.data[ 169 ]= 2.6143 ; 
range.data[ 170 ]= 2.6003 ; 
range.data[ 171 ]= 2.5862 ; 
range.data[ 172 ]= 2.5747 ; 
range.data[ 173 ]= 2.56 ; 
range.data[ 174 ]= 2.5475 ; 
range.data[ 175 ]= 2.5314 ; 
range.data[ 176 ]= 2.5194 ; 
range.data[ 177 ]= 2.5079 ; 
range.data[ 178 ]= 2.4958 ; 
range.data[ 179 ]= 2.4814 ; 
range.data[ 180 ]= 2.4713 ; 
range.data[ 181 ]= 2.4619 ; 
range.data[ 182 ]= 2.4416 ; 
range.data[ 183 ]= 2.4321 ; 
range.data[ 184 ]= 2.4333 ; 
range.data[ 185 ]= 2.4303 ; 
range.data[ 186 ]= 2.4256 ; 
range.data[ 187 ]= 2.4219 ; 
range.data[ 188 ]= 2.418 ; 
range.data[ 189 ]= 2.4179 ; 
range.data[ 190 ]= 2.414 ; 
range.data[ 191 ]= 2.4084 ; 
range.data[ 192 ]= 2.4068 ; 
range.data[ 193 ]= 2.405 ; 
range.data[ 194 ]= 2.4024 ; 
range.data[ 195 ]= 2.4016 ; 
range.data[ 196 ]= 2.4013 ; 
range.data[ 197 ]= 2.3981 ; 
range.data[ 198 ]= 2.3959 ; 
range.data[ 199 ]= 2.3933 ; 
range.data[ 200 ]= 2.3918 ; 
range.data[ 201 ]= 2.3952 ; 
range.data[ 202 ]= 2.3906 ; 
range.data[ 203 ]= 2.3924 ; 
range.data[ 204 ]= 2.3898 ; 
range.data[ 205 ]= 2.3934 ; 
range.data[ 206 ]= 2.3939 ; 
range.data[ 207 ]= 2.3908 ; 
range.data[ 208 ]= 2.3909 ; 
range.data[ 209 ]= 2.3926 ; 
range.data[ 210 ]= 2.3951 ; 
range.data[ 211 ]= 2.3963 ; 
range.data[ 212 ]= 2.4122 ; 
range.data[ 213 ]= 2.4221 ; 
range.data[ 214 ]= 2.4369 ; 
range.data[ 215 ]= 2.4532 ; 
range.data[ 216 ]= 2.468 ; 
range.data[ 217 ]= 2.4843 ; 
range.data[ 218 ]= 2.4985 ; 
range.data[ 219 ]= 2.5148 ; 
range.data[ 220 ]= 2.5332 ; 
range.data[ 221 ]= 2.5479 ; 
range.data[ 222 ]= 2.5668 ; 
range.data[ 223 ]= 2.5828 ; 
range.data[ 224 ]= 2.6014 ; 
range.data[ 225 ]= 2.6213 ; 
range.data[ 226 ]= 2.64 ; 
range.data[ 227 ]= 2.6608 ; 
range.data[ 228 ]= 2.678 ; 
range.data[ 229 ]= 2.7006 ; 
range.data[ 230 ]= 2.7193 ; 
range.data[ 231 ]= 2.74 ; 
range.data[ 232 ]= 2.7811 ; 
range.data[ 233 ]= 2.8527 ; 
range.data[ 234 ]= 2.9282 ; 
range.data[ 235 ]= 3.0124 ; 
range.data[ 236 ]= 3.0953 ; 
range.data[ 237 ]= 3.1824 ; 
range.data[ 238 ]= 3.2792 ; 
range.data[ 239 ]= 3.3401 ; 
range.data[ 240 ]= 3.355 ; 
range.data[ 241 ]= 3.3535 ; 
range.data[ 242 ]= 3.3565 ; 
range.data[ 243 ]= 3.3583 ; 
range.data[ 244 ]= 3.3597 ; 
range.data[ 245 ]= 3.3578 ; 
range.data[ 246 ]= 3.3615 ; 
range.data[ 247 ]= 3.3601 ; 
range.data[ 248 ]= 3.3614 ; 
range.data[ 249 ]= 3.3606 ; 
range.data[ 250 ]= 3.3644 ; 
range.data[ 251 ]= 3.3674 ; 
range.data[ 252 ]= 3.3712 ; 
range.data[ 253 ]= 3.3724 ; 
range.data[ 254 ]= 3.3755 ; 
range.data[ 255 ]= 3.3799 ; 
range.data[ 256 ]= 3.3847 ; 
range.data[ 257 ]= 3.3906 ; 
range.data[ 258 ]= 3.6833 ; 
range.data[ 259 ]= 3.6835 ; 
range.data[ 260 ]= 3.694 ; 
range.data[ 261 ]= 3.6972 ; 
range.data[ 262 ]= 3.705 ; 
range.data[ 263 ]= 3.7061 ; 
range.data[ 264 ]= 3.7177 ; 
range.data[ 265 ]= 3.7247 ; 
range.data[ 266 ]= 3.7329 ; 
range.data[ 267 ]= 3.7399 ; 
range.data[ 268 ]= 3.7428 ; 
range.data[ 269 ]= 3.7552 ; 
range.data[ 270 ]= 3.4627 ; 
range.data[ 271 ]= 3.4734 ; 
range.data[ 272 ]= 3.4827 ; 
range.data[ 273 ]= 3.49 ; 
range.data[ 274 ]= 3.4972 ; 
range.data[ 275 ]= 3.5032 ; 
range.data[ 276 ]= 3.5142 ; 
range.data[ 277 ]= 3.526 ; 
range.data[ 278 ]= 3.5388 ; 
range.data[ 279 ]= 3.5459 ; 
range.data[ 280 ]= 3.5561 ; 
range.data[ 281 ]= 3.5656 ; 
range.data[ 282 ]= 3.5829 ; 
range.data[ 283 ]= 3.5909 ; 
range.data[ 284 ]= 3.6014 ; 
range.data[ 285 ]= 3.6139 ; 
range.data[ 286 ]= 3.6284 ; 
range.data[ 287 ]= 3.6454 ; 
range.data[ 288 ]= 4.601 ; 
range.data[ 289 ]= 4.5086 ; 
range.data[ 290 ]= 2.0579 ; 
range.data[ 291 ]= 2.052 ; 
range.data[ 292 ]= 2.0146 ; 
range.data[ 293 ]= 1.9781 ; 
range.data[ 294 ]= 1.9415 ; 
range.data[ 295 ]= 1.9034 ; 
range.data[ 296 ]= 1.8721 ; 
range.data[ 297 ]= 1.8399 ; 
range.data[ 298 ]= 1.8066 ; 
range.data[ 299 ]= 1.7779 ; 
range.data[ 300 ]= 1.7498 ; 
range.data[ 301 ]= 1.7215 ; 
range.data[ 302 ]= 1.6435 ; 
range.data[ 303 ]= 1.6273 ; 
range.data[ 304 ]= 1.6365 ; 
range.data[ 305 ]= 1.657 ; 
range.data[ 306 ]= 1.666 ; 
range.data[ 307 ]= 1.6755 ; 
range.data[ 308 ]= 1.6866 ; 
range.data[ 309 ]= 1.6946 ; 
range.data[ 310 ]= 1.7072 ; 
range.data[ 311 ]= 1.7177 ; 
range.data[ 312 ]= 1.726 ; 
range.data[ 313 ]= 1.7389 ; 
range.data[ 314 ]= 1.7495 ; 
range.data[ 315 ]= 1.7611 ; 
range.data[ 316 ]= 1.7743 ; 
range.data[ 317 ]= 1.7886 ; 
range.data[ 318 ]= 1.8013 ; 
range.data[ 319 ]= 1.8115 ; 
range.data[ 320 ]= 1.8256 ; 
range.data[ 321 ]= 1.8413 ; 
range.data[ 322 ]= 1.8556 ; 
range.data[ 323 ]= 1.8689 ; 
range.data[ 324 ]= 1.8816 ; 
range.data[ 325 ]= 1.8977 ; 
range.data[ 326 ]= 1.9141 ; 
range.data[ 327 ]= 1.9314 ; 
range.data[ 328 ]= 1.9447 ; 
range.data[ 329 ]= 1.9618 ; 
range.data[ 330 ]= 1.9805 ; 
range.data[ 331 ]= 2.0097 ; 
range.data[ 332 ]= 2.0279 ; 
range.data[ 333 ]= 2.0443 ; 
range.data[ 334 ]= 2.0643 ; 
range.data[ 335 ]= 2.0858 ; 
range.data[ 336 ]= 2.1029 ; 
range.data[ 337 ]= 2.1248 ; 
range.data[ 338 ]= 2.1481 ; 
range.data[ 339 ]= 2.1681 ; 
range.data[ 340 ]= 2.1915 ; 
range.data[ 341 ]= 2.2173 ; 
range.data[ 342 ]= 2.241 ; 
range.data[ 343 ]= 2.2628 ; 
range.data[ 344 ]= 2.29 ; 
range.data[ 345 ]= 2.2763 ; 
range.data[ 346 ]= 2.2687 ; 
range.data[ 347 ]= 2.253 ; 
range.data[ 348 ]= 2.2389 ; 
range.data[ 349 ]= 2.2252 ; 
range.data[ 350 ]= 2.2073 ; 
range.data[ 351 ]= 2.1956 ; 
range.data[ 352 ]= 2.1799 ; 
range.data[ 353 ]= 2.1677 ; 
range.data[ 354 ]= 2.1543 ; 
range.data[ 355 ]= 2.1412 ; 
range.data[ 356 ]= 2.1268 ; 
range.data[ 357 ]= 2.1144 ; 
range.data[ 358 ]= 2.106 ; 
range.data[ 359 ]= 2.0925 ; 
range.data[ 360 ]= 2.0829 ; 
}

void initAlmostHit()
{
	actual = "should have been: 2.82,-0.03,-0.83";
	
	range.length= 361 ; 
	range.fov= 3.1415 ; 
	range.resolution= 0.0087 ; 
	range.maxRange= 15 ; 
	range.minRange= 0.01 ; 
	range.data = new double[ 361 ]; 
	range.data[ 0 ]= 3.1251 ; 
	range.data[ 1 ]= 3.1389 ; 
	range.data[ 2 ]= 3.1558 ; 
	range.data[ 3 ]= 3.1683 ; 
	range.data[ 4 ]= 3.1772 ; 
	range.data[ 5 ]= 3.1938 ; 
	range.data[ 6 ]= 3.2091 ; 
	range.data[ 7 ]= 3.2251 ; 
	range.data[ 8 ]= 3.2411 ; 
	range.data[ 9 ]= 3.2559 ; 
	range.data[ 10 ]= 3.2704 ; 
	range.data[ 11 ]= 3.2858 ; 
	range.data[ 12 ]= 3.3083 ; 
	range.data[ 13 ]= 3.3252 ; 
	range.data[ 14 ]= 3.3414 ; 
	range.data[ 15 ]= 3.364 ; 
	range.data[ 16 ]= 3.3827 ; 
	range.data[ 17 ]= 3.4013 ; 
	range.data[ 18 ]= 3.419 ; 
	range.data[ 19 ]= 3.4412 ; 
	range.data[ 20 ]= 3.4605 ; 
	range.data[ 21 ]= 3.4848 ; 
	range.data[ 22 ]= 3.5032 ; 
	range.data[ 23 ]= 3.5254 ; 
	range.data[ 24 ]= 3.5491 ; 
	range.data[ 25 ]= 3.5739 ; 
	range.data[ 26 ]= 3.6009 ; 
	range.data[ 27 ]= 3.6212 ; 
	range.data[ 28 ]= 3.6457 ; 
	range.data[ 29 ]= 3.6661 ; 
	range.data[ 30 ]= 3.6396 ; 
	range.data[ 31 ]= 3.6052 ; 
	range.data[ 32 ]= 3.5692 ; 
	range.data[ 33 ]= 3.5315 ; 
	range.data[ 34 ]= 3.4915 ; 
	range.data[ 35 ]= 3.4604 ; 
	range.data[ 36 ]= 3.426 ; 
	range.data[ 37 ]= 3.3897 ; 
	range.data[ 38 ]= 3.3575 ; 
	range.data[ 39 ]= 3.3146 ; 
	range.data[ 40 ]= 3.2924 ; 
	range.data[ 41 ]= 3.2595 ; 
	range.data[ 42 ]= 3.2298 ; 
	range.data[ 43 ]= 3.1997 ; 
	range.data[ 44 ]= 3.1767 ; 
	range.data[ 45 ]= 3.1462 ; 
	range.data[ 46 ]= 3.1218 ; 
	range.data[ 47 ]= 3.0948 ; 
	range.data[ 48 ]= 3.0703 ; 
	range.data[ 49 ]= 3.0465 ; 
	range.data[ 50 ]= 3.0274 ; 
	range.data[ 51 ]= 3.0016 ; 
	range.data[ 52 ]= 2.9716 ; 
	range.data[ 53 ]= 2.9606 ; 
	range.data[ 54 ]= 3.0114 ; 
	range.data[ 55 ]= 3.0446 ; 
	range.data[ 56 ]= 3.0757 ; 
	range.data[ 57 ]= 3.1159 ; 
	range.data[ 58 ]= 3.1557 ; 
	range.data[ 59 ]= 3.1934 ; 
	range.data[ 60 ]= 3.2312 ; 
	range.data[ 61 ]= 3.272 ; 
	range.data[ 62 ]= 3.3156 ; 
	range.data[ 63 ]= 3.3603 ; 
	range.data[ 64 ]= 3.4083 ; 
	range.data[ 65 ]= 3.4524 ; 
	range.data[ 66 ]= 3.5024 ; 
	range.data[ 67 ]= 3.5521 ; 
	range.data[ 68 ]= 3.5995 ; 
	range.data[ 69 ]= 3.6597 ; 
	range.data[ 70 ]= 3.7067 ; 
	range.data[ 71 ]= 3.7656 ; 
	range.data[ 72 ]= 4.1226 ; 
	range.data[ 73 ]= 4.1064 ; 
	range.data[ 74 ]= 4.0872 ; 
	range.data[ 75 ]= 4.0687 ; 
	range.data[ 76 ]= 4.0484 ; 
	range.data[ 77 ]= 4.0261 ; 
	range.data[ 78 ]= 4.0141 ; 
	range.data[ 79 ]= 3.9923 ; 
	range.data[ 80 ]= 3.9782 ; 
	range.data[ 81 ]= 3.9591 ; 
	range.data[ 82 ]= 3.9409 ; 
	range.data[ 83 ]= 3.9263 ; 
	range.data[ 84 ]= 3.91 ; 
	range.data[ 85 ]= 3.8981 ; 
	range.data[ 86 ]= 3.8844 ; 
	range.data[ 87 ]= 3.8666 ; 
	range.data[ 88 ]= 3.8596 ; 
	range.data[ 89 ]= 1.3976 ; 
	range.data[ 90 ]= 1.3901 ; 
	range.data[ 91 ]= 1.3637 ; 
	range.data[ 92 ]= 1.3396 ; 
	range.data[ 93 ]= 1.3129 ; 
	range.data[ 94 ]= 1.2881 ; 
	range.data[ 95 ]= 1.2642 ; 
	range.data[ 96 ]= 1.2417 ; 
	range.data[ 97 ]= 1.2198 ; 
	range.data[ 98 ]= 1.1989 ; 
	range.data[ 99 ]= 1.1793 ; 
	range.data[ 100 ]= 1.161 ; 
	range.data[ 101 ]= 1.1411 ; 
	range.data[ 102 ]= 1.1242 ; 
	range.data[ 103 ]= 1.1063 ; 
	range.data[ 104 ]= 1.0898 ; 
	range.data[ 105 ]= 1.073 ; 
	range.data[ 106 ]= 1.0575 ; 
	range.data[ 107 ]= 1.0431 ; 
	range.data[ 108 ]= 1.0272 ; 
	range.data[ 109 ]= 1.0128 ; 
	range.data[ 110 ]= 0.9998 ; 
	range.data[ 111 ]= 0.9852 ; 
	range.data[ 112 ]= 0.9726 ; 
	range.data[ 113 ]= 0.9597 ; 
	range.data[ 114 ]= 0.9488 ; 
	range.data[ 115 ]= 0.9353 ; 
	range.data[ 116 ]= 0.924 ; 
	range.data[ 117 ]= 0.9136 ; 
	range.data[ 118 ]= 0.9025 ; 
	range.data[ 119 ]= 0.8923 ; 
	range.data[ 120 ]= 0.8815 ; 
	range.data[ 121 ]= 0.872 ; 
	range.data[ 122 ]= 0.861 ; 
	range.data[ 123 ]= 0.8528 ; 
	range.data[ 124 ]= 0.8439 ; 
	range.data[ 125 ]= 0.8343 ; 
	range.data[ 126 ]= 0.8251 ; 
	range.data[ 127 ]= 0.8173 ; 
	range.data[ 128 ]= 0.8092 ; 
	range.data[ 129 ]= 0.8017 ; 
	range.data[ 130 ]= 0.7923 ; 
	range.data[ 131 ]= 0.7854 ; 
	range.data[ 132 ]= 0.7786 ; 
	range.data[ 133 ]= 0.7711 ; 
	range.data[ 134 ]= 0.764 ; 
	range.data[ 135 ]= 0.7571 ; 
	range.data[ 136 ]= 0.7507 ; 
	range.data[ 137 ]= 0.7442 ; 
	range.data[ 138 ]= 0.7369 ; 
	range.data[ 139 ]= 0.7318 ; 
	range.data[ 140 ]= 0.7251 ; 
	range.data[ 141 ]= 0.7192 ; 
	range.data[ 142 ]= 0.7139 ; 
	range.data[ 143 ]= 0.708 ; 
	range.data[ 144 ]= 0.7027 ; 
	range.data[ 145 ]= 0.6975 ; 
	range.data[ 146 ]= 0.6923 ; 
	range.data[ 147 ]= 0.6873 ; 
	range.data[ 148 ]= 0.6821 ; 
	range.data[ 149 ]= 0.6774 ; 
	range.data[ 150 ]= 0.6725 ; 
	range.data[ 151 ]= 0.6675 ; 
	range.data[ 152 ]= 0.6633 ; 
	range.data[ 153 ]= 0.6591 ; 
	range.data[ 154 ]= 0.6554 ; 
	range.data[ 155 ]= 0.6503 ; 
	range.data[ 156 ]= 0.637 ; 
	range.data[ 157 ]= 0.6327 ; 
	range.data[ 158 ]= 0.6289 ; 
	range.data[ 159 ]= 0.6271 ; 
	range.data[ 160 ]= 0.6372 ; 
	range.data[ 161 ]= 1.5615 ; 
	range.data[ 162 ]= 1.5089 ; 
	range.data[ 163 ]= 1.461 ; 
	range.data[ 164 ]= 1.3879 ; 
	range.data[ 165 ]= 1.3754 ; 
	range.data[ 166 ]= 1.3782 ; 
	range.data[ 167 ]= 2.6995 ; 
	range.data[ 168 ]= 2.6719 ; 
	range.data[ 169 ]= 2.6489 ; 
	range.data[ 170 ]= 2.6328 ; 
	range.data[ 171 ]= 2.6173 ; 
	range.data[ 172 ]= 2.6063 ; 
	range.data[ 173 ]= 2.5938 ; 
	range.data[ 174 ]= 2.5906 ; 
	range.data[ 175 ]= 2.5812 ; 
	range.data[ 176 ]= 2.5759 ; 
	range.data[ 177 ]= 2.5741 ; 
	range.data[ 178 ]= 2.5712 ; 
	range.data[ 179 ]= 2.5712 ; 
	range.data[ 180 ]= 2.5765 ; 
	range.data[ 181 ]= 2.576 ; 
	range.data[ 182 ]= 2.5811 ; 
	range.data[ 183 ]= 2.5867 ; 
	range.data[ 184 ]= 2.5959 ; 
	range.data[ 185 ]= 2.6081 ; 
	range.data[ 186 ]= 2.617 ; 
	range.data[ 187 ]= 2.632 ; 
	range.data[ 188 ]= 2.6543 ; 
	range.data[ 189 ]= 2.6759 ; 
	range.data[ 190 ]= 2.6987 ; 
	range.data[ 191 ]= 2.7339 ; 
	range.data[ 192 ]= 2.7813 ; 
	range.data[ 193 ]= 2.8607 ; 
	range.data[ 194 ]= 3.8601 ; 
	range.data[ 195 ]= 3.8783 ; 
	range.data[ 196 ]= 3.9 ; 
	range.data[ 197 ]= 3.9264 ; 
	range.data[ 198 ]= 3.9468 ; 
	range.data[ 199 ]= 3.9769 ; 
	range.data[ 200 ]= 3.9953 ; 
	range.data[ 201 ]= 4.0212 ; 
	range.data[ 202 ]= 4.0443 ; 
	range.data[ 203 ]= 4.071 ; 
	range.data[ 204 ]= 4.1019 ; 
	range.data[ 205 ]= 4.1282 ; 
	range.data[ 206 ]= 4.152 ; 
	range.data[ 207 ]= 4.1845 ; 
	range.data[ 208 ]= 4.209 ; 
	range.data[ 209 ]= 4.2427 ; 
	range.data[ 210 ]= 4.2781 ; 
	range.data[ 211 ]= 4.3031 ; 
	range.data[ 212 ]= 4.3391 ; 
	range.data[ 213 ]= 4.3742 ; 
	range.data[ 214 ]= 4.4077 ; 
	range.data[ 215 ]= 4.4413 ; 
	range.data[ 216 ]= 4.479 ; 
	range.data[ 217 ]= 4.5118 ; 
	range.data[ 218 ]= 4.5534 ; 
	range.data[ 219 ]= 4.59 ; 
	range.data[ 220 ]= 4.6326 ; 
	range.data[ 221 ]= 4.6663 ; 
	range.data[ 222 ]= 4.7111 ; 
	range.data[ 223 ]= 3.5606 ; 
	range.data[ 224 ]= 3.5408 ; 
	range.data[ 225 ]= 3.5132 ; 
	range.data[ 226 ]= 3.4854 ; 
	range.data[ 227 ]= 3.4633 ; 
	range.data[ 228 ]= 3.4402 ; 
	range.data[ 229 ]= 3.4174 ; 
	range.data[ 230 ]= 3.3893 ; 
	range.data[ 231 ]= 3.3667 ; 
	range.data[ 232 ]= 3.3464 ; 
	range.data[ 233 ]= 3.3272 ; 
	range.data[ 234 ]= 3.3038 ; 
	range.data[ 235 ]= 3.2817 ; 
	range.data[ 236 ]= 3.2606 ; 
	range.data[ 237 ]= 3.2425 ; 
	range.data[ 238 ]= 3.2278 ; 
	range.data[ 239 ]= 3.2072 ; 
	range.data[ 240 ]= 3.1914 ; 
	range.data[ 241 ]= 3.1744 ; 
	range.data[ 242 ]= 3.157 ; 
	range.data[ 243 ]= 3.1387 ; 
	range.data[ 244 ]= 3.1227 ; 
	range.data[ 245 ]= 3.108 ; 
	range.data[ 246 ]= 3.0913 ; 
	range.data[ 247 ]= 3.0759 ; 
	range.data[ 248 ]= 3.0596 ; 
	range.data[ 249 ]= 3.0441 ; 
	range.data[ 250 ]= 3.0227 ; 
	range.data[ 251 ]= 3.0194 ; 
	range.data[ 252 ]= 3.0172 ; 
	range.data[ 253 ]= 3.0129 ; 
	range.data[ 254 ]= 3.0065 ; 
	range.data[ 255 ]= 3.0034 ; 
	range.data[ 256 ]= 2.9937 ; 
	range.data[ 257 ]= 2.9921 ; 
	range.data[ 258 ]= 2.9894 ; 
	range.data[ 259 ]= 2.9857 ; 
	range.data[ 260 ]= 2.9829 ; 
	range.data[ 261 ]= 2.9759 ; 
	range.data[ 262 ]= 2.9747 ; 
	range.data[ 263 ]= 2.969 ; 
	range.data[ 264 ]= 2.9666 ; 
	range.data[ 265 ]= 2.9644 ; 
	range.data[ 266 ]= 2.9627 ; 
	range.data[ 267 ]= 2.9614 ; 
	range.data[ 268 ]= 2.9623 ; 
	range.data[ 269 ]= 2.9578 ; 
	range.data[ 270 ]= 2.9569 ; 
	range.data[ 271 ]= 2.9565 ; 
	range.data[ 272 ]= 2.9554 ; 
	range.data[ 273 ]= 2.9546 ; 
	range.data[ 274 ]= 2.9719 ; 
	range.data[ 275 ]= 2.9866 ; 
	range.data[ 276 ]= 2.9989 ; 
	range.data[ 277 ]= 3.0119 ; 
	range.data[ 278 ]= 3.032 ; 
	range.data[ 279 ]= 3.0449 ; 
	range.data[ 280 ]= 3.064 ; 
	range.data[ 281 ]= 3.0807 ; 
	range.data[ 282 ]= 3.0947 ; 
	range.data[ 283 ]= 3.1142 ; 
	range.data[ 284 ]= 3.1342 ; 
	range.data[ 285 ]= 3.151 ; 
	range.data[ 286 ]= 3.1704 ; 
	range.data[ 287 ]= 3.1893 ; 
	range.data[ 288 ]= 3.2133 ; 
	range.data[ 289 ]= 3.234 ; 
	range.data[ 290 ]= 3.255 ; 
	range.data[ 291 ]= 3.2752 ; 
	range.data[ 292 ]= 3.334 ; 
	range.data[ 293 ]= 3.397 ; 
	range.data[ 294 ]= 3.4665 ; 
	range.data[ 295 ]= 3.546 ; 
	range.data[ 296 ]= 3.6192 ; 
	range.data[ 297 ]= 3.6911 ; 
	range.data[ 298 ]= 3.7814 ; 
	range.data[ 299 ]= 3.8456 ; 
	range.data[ 300 ]= 3.861 ; 
	range.data[ 301 ]= 3.8604 ; 
	range.data[ 302 ]= 3.8547 ; 
	range.data[ 303 ]= 3.8493 ; 
	range.data[ 304 ]= 3.8527 ; 
	range.data[ 305 ]= 3.8478 ; 
	range.data[ 306 ]= 3.8455 ; 
	range.data[ 307 ]= 3.846 ; 
	range.data[ 308 ]= 3.8431 ; 
	range.data[ 309 ]= 3.8441 ; 
	range.data[ 310 ]= 3.8418 ; 
	range.data[ 311 ]= 3.8418 ; 
	range.data[ 312 ]= 3.8411 ; 
	range.data[ 313 ]= 3.8423 ; 
	range.data[ 314 ]= 3.8459 ; 
	range.data[ 315 ]= 3.8447 ; 
	range.data[ 316 ]= 4.1351 ; 
	range.data[ 317 ]= 4.1359 ; 
	range.data[ 318 ]= 4.1369 ; 
	range.data[ 319 ]= 4.1443 ; 
	range.data[ 320 ]= 4.146 ; 
	range.data[ 321 ]= 4.1431 ; 
	range.data[ 322 ]= 4.1519 ; 
	range.data[ 323 ]= 4.155 ; 
	range.data[ 324 ]= 4.157 ; 
	range.data[ 325 ]= 4.1623 ; 
	range.data[ 326 ]= 4.1688 ; 
	range.data[ 327 ]= 3.877 ; 
	range.data[ 328 ]= 3.8836 ; 
	range.data[ 329 ]= 3.891 ; 
	range.data[ 330 ]= 3.8991 ; 
	range.data[ 331 ]= 3.8987 ; 
	range.data[ 332 ]= 3.91 ; 
	range.data[ 333 ]= 3.9149 ; 
	range.data[ 334 ]= 3.9229 ; 
	range.data[ 335 ]= 3.9333 ; 
	range.data[ 336 ]= 2.4139 ; 
	range.data[ 337 ]= 2.4154 ; 
	range.data[ 338 ]= 2.3274 ; 
	range.data[ 339 ]= 2.2426 ; 
	range.data[ 340 ]= 2.1632 ; 
	range.data[ 341 ]= 2.0927 ; 
	range.data[ 342 ]= 1.9482 ; 
	range.data[ 343 ]= 1.9542 ; 
	range.data[ 344 ]= 1.9696 ; 
	range.data[ 345 ]= 1.9727 ; 
	range.data[ 346 ]= 1.9807 ; 
	range.data[ 347 ]= 1.9851 ; 
	range.data[ 348 ]= 1.9912 ; 
	range.data[ 349 ]= 1.9962 ; 
	range.data[ 350 ]= 2.0059 ; 
	range.data[ 351 ]= 2.0112 ; 
	range.data[ 352 ]= 2.0161 ; 
	range.data[ 353 ]= 2.0248 ; 
	range.data[ 354 ]= 2.0306 ; 
	range.data[ 355 ]= 2.0386 ; 
	range.data[ 356 ]= 2.0457 ; 
	range.data[ 357 ]= 2.0536 ; 
	range.data[ 358 ]= 2.0633 ; 
	range.data[ 359 ]= 2.0713 ; 
	range.data[ 360 ]= 2.0801 ;	
}
