
#ifndef CUBEAGENT_H
#define CUBEAGENT_H



#include "Octree.hpp"

#include <vector>
#include <iostream>

#include "Cube.h"


using namespace hxa7241_graphics;


class CubeAgent
    : public OctreeAgent<Cube>
{

public:

    CubeAgent() {};

    virtual ~CubeAgent() {};


private:

    CubeAgent(const CubeAgent&);
	CubeAgent& operator=(const CubeAgent&);


protected:

    virtual bool  isOverlappingCell (const Cube&     item,
	                                 const Vector3f& lowerCorner,
	                                 const Vector3f& upperCorner) const;

    virtual dword getSubcellOverlaps(const Cube&     item,
	                                 const Vector3f& lower,
	                                 const Vector3f& middle,
	                                 const Vector3f& upper) const;
};


#endif
