/*
	This widget represents a collapsable box
*/

#ifndef CONTROLBOX_H
#define CONTROLBOX_H

#include <QWidget>
#include <QString>
#include <QMap>
#include <QMapIterator>
#include <QVBoxLayout>

#include "controlboxhead.h"

class ControlBox : public QWidget
{
	Q_OBJECT
	public
		/* constructs a control box
		*/:
		ControlBox(QString, QWidget *);
		virtual ~ControlBox();

		void addWidget(QString, QWidget *);

		QString getName() const { return mvTitle; }

	public slots:
		void collapse();
		void hideControl(QString);

		void expand();
		void showControl(QString);

		void toggled(bool);


	private:
		QMap<QString, QWidget*> mvChildDict;

		QWidget * mvContentBox;
		QVBoxLayout * mvContentLayout;
		
		QVBoxLayout * mvLayout;

		ControlBoxHead * mvHead;

		QString mvTitle;
};


#endif //CONTROLBOX_H
