#include "GLManifoldRenderer.h"

GLManifoldRenderer::GLManifoldRenderer()
{
}

GLManifoldRenderer::~GLManifoldRenderer()
{
}

void GLManifoldRenderer::renderScan(Pose2D scanPose, ScanObservation* scan, uint number = 0)
{
	glPushMatrix();
	
		glTranslatef(scanPose.x,scanPose.y,);
		glRotatef(scanPose.rot * 180 / M_PI,0.0,0.0,1.0);
		
		if( displayLists.contains( scan->getUniqueID() ) )
		{
			glCallList( displayLists.value( scan->getUniqueID() ) );
		}
		else // build a display list
		{
			GLuint list = glGenLists(1);
			
			Vector3 vLocalLeft;
			Vector3 vLocalMid;
			Vector3 vLocalRight;
			
			glNewList(list, GL_COMPILE_AND_EXECUTE);
			
				glColor4f(1,1,1,.2);
		
				float step = M_PI/180/3;
	
			    for (uint i = 0; i < scan->length; i++) {
					a = M_PI/180*i - M_PI_2;
			        
					vLocalLeft = Vector3( scan->range[i] * cos(a-step), scan->range[i] * sin(a-step), 0 );
					vLocalMid = Vector3( scan->range[i] * cos(a), scan->range[i] * sin(a), 0 );
					vLocalRight = Vector3( scan->range[i] * cos(a+step), scan->range[i] * sin(a+step), 0 );
					
					glColor4f(1,1,1,.2);
					
					glBegin(GL_LINES);
						
						glVertex3f( vLocalLeft.x, vLocalLeft.y, vLocalLeft.z );
						glVertex3f( vLocalMid.x, vLocalMid.y, vLocalMid.z );
						glVertex3f( vLocalRight.x, vLocalRight.y, vLocalRight.z );

					glEnd();
					
					glColor4f(1,0,0,.2);
					
					glBegin(GL_POINTS);
						glVertex3f( vLocalMid.x, vLocalMid.y, vLocalMid.z );
					glEnd();
			        
			    }
		
			glEndList();
			
			displayLists.insert( scan->getUniqueID(), list );
		}
	
	glPopMatrix();
}

void GLManifoldRenderer::renderLink(Pose2D firstPose, Pose2D secondPose) 
{
	
}
