
#include <QApplication>
#include <QPushButton>
#include <QColor>

#include <math.h>

#include "GLManifoldSlamView.h"

#include "ScanUtils.h"

#include "Manifold.h"
#include "ManifoldSlam.h"
#include "WeightedScanMatcher.h"


#include "commandermainwindow.h"

#include "Util3D.h"

int main(int argc, char **argv )
{

	QApplication app(argc,argv);

	CommanderMainWindow *mainWin = new CommanderMainWindow(0);
	
	Manifold manifold;
	WeightedScanMatcher scanmatcher;
	ManifoldSlam slam(&scanmatcher, &manifold);
	
	
	

	// SET UP THE MAIN WINDOW

	// *************************************************************
	// add control categories

	mainWin->addControlCategory("Modes");
	mainWin->addControlCategory("Robots");
	mainWin->addControlCategory("Steering");
	mainWin->addControlCategory("Map");

	// *************************************************************
	// add control widgets

	mainWin->addControlWidget("Modes","TEST",new QPushButton("hello"));
	
	mainWin->addControlWidget("Steering","joystick",new PositionController(&position));
	
	// *************************************************************
	// add GL views
	
	mainWin->getCanvas()->addView( 0, new GLMapView(map) );
	
	// SETUP done
	// *************************************************************

	mainWin->resize(500,500);

	//app.setMainWidget( mainWin );
	mainWin->setWindowTitle("USAR Commander");
	mainWin->show();

	int result = app.exec();
	delete mainWin;
	delete map;
	
	// wait until we are disconnected
	agent.disconnect();
	agent.wait();
	
	return result;
}
