#ifndef CLIENT_H_
#define CLIENT_H_

#include <QString>
#include <QMutex>
#include <QWaitCondition>
#include <QUuid>
#include <QString>
#include <QByteArray>
#include <QMap>

//#include "Manifold.h"
//#include "ScanUtils.h"
//#include "Util3D.h"

#include "Connection.h"
#include "Server.h"

class Conversation : public ConversationId
{
private:
	QByteArray returnValue;
	
	QMutex mutex;
	QWaitCondition waiter;
	
public:
	Conversation();
	
	QByteArray getReturnValue();
	void setReturnValue(QByteArray);
	
	void suspend();
	void resume();
};

class ClientBroadcastListener
{
public:
	ClientBroadcastListener() {}
	virtual ~ClientBroadcastListener() {}
	
	virtual void receivedBroadcast(QByteArray) = 0;
};

class Client : public Connection
{
private:
	
	QString host;
	uint port;
	
	QMap<QUuid, Conversation*> conversations;
	
	ClientBroadcastListener* listener;
	
protected:
	
	void suspend(Conversation*);
	void resume(Conversation*);
	
	void received(QUuid&, QByteArray);
	
public:
	Client(QString, uint);
	virtual ~Client();
	
	void setListener(ClientBroadcastListener*);
	
	bool connect();
	
	QString echo(QString);
	void put(QString);
	
//	Manifold* getSubMap(ScanObservation*);
//	
//	void sendPoseUpdate(const Pose3D&, ScanObservation*);
};

#endif /*CLIENT_H_*/
