#ifndef SERVER_H_
#define SERVER_H_

#include <QThread>
#include <QList>
#include <QListIterator>

#include "XServer.h"
#include "Connection.h"

class Server;

class ServerConnection : public Connection
{
private:
	Server* parent;
	
protected:
	virtual void received(QUuid&, QByteArray){};
	
public:
	ServerConnection(XSocket*, Server*);
	virtual ~ServerConnection();
	
	virtual void run();
	
};

class Server : public QThread
{
private:
	uint port;
	XServer serverSocket;
	
	ServerConnection* currentConnection;
	
	QList<ServerConnection*> connections;
	QList<ServerConnection*> toBeDeleted;

protected:
	void removeConnection(ServerConnection*);

	virtual ServerConnection* newServerConnection(XSocket*);

public:
	Server(uint);
	virtual ~Server();
	
	QListIterator<ServerConnection*> connectionIterator();
	
	ServerConnection* getConnection(int);
	int countConnections();

	virtual void run();
	
	void disconnect();
	void disconnectClients();
	
	void broadcast(const QByteArray&);
	
	friend class ServerConnection;
};

#endif /*SERVER_H_*/
