
/*
 * THIS IS THE UNIX IMPLEMENTATION!
 */

#ifndef XSOCKET_H_
#define XSOCKET_H_

#include <unistd.h>
#include <errno.h>
#include <string.h>
#include <arpa/inet.h>
#include <netinet/in.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/select.h>
#include <sys/socket.h>

#include <QString>
#include <QByteArray>
#include <QQueue>

#include "Exception.h"

// simple synchronous socket wrapper with standardized interface
class XSocket
{
protected:
	int sockfd;
	sockaddr_in remoteAddr;
	
	static bool sighandleInitialized;
	
	bool aIsConnected;
	
	char* buf;
	unsigned int alreadyReadBefore;
	
	QQueue< QString > receiveQueue;
	QQueue< QByteArray > receiveBytesQueue;
	
	QQueue< QByteArray > sendWhenDisconnectedQueue;
	bool queueWhenDisconnected;
	
	int findNextCRLF(char*, int, int);
	int copyToFrontOfBuffer(int, int);
	
	int sendAll(const QByteArray&);
	
	bool waitForData(unsigned long);
	void readMore();
	
public:
	static const int BUFSIZE;

	XSocket(int);

	XSocket();
	virtual ~XSocket();
	
	virtual void setQueueWhenDisconnected(bool);
	
	virtual void connect(const QString&, uint);
	
	virtual void disconnect();
	
	virtual bool isConnected();
	
	virtual int send(const QString&);
	virtual QString receive(unsigned long);
	
	virtual int sendBytes(const QByteArray&);
	virtual QByteArray receiveBytes(unsigned long);
	
	virtual QString lastError();
};

#endif /*XSOCKET_H_*/
