#include "TestServer.h"

#include <QtDebug>

TestServerConnection::TestServerConnection(XSocket* sock, Server* serv)
	: ServerConnection(sock, serv)
{

}

void TestServerConnection::received(QUuid& id, QByteArray data)
{
	qDebug() << "received: " << id;

	QDataStream str(data);
	QString method;
	str >> method;

	if( method == "echo" )
	{
		QString content;
		str >> content;

		qDebug() << "do echo method on string: " << content;

		QByteArray ret;
		QDataStream out(&ret, QIODevice::WriteOnly);
		out << content;

		send(id, ret);
	}
	else if(method == "put")
	{
		QString content;
		str >> content;
		
		qDebug() << "received put: " << content;
	}
	else
	{
		qDebug() << "unknown method: " << method;
	}
}

TestServer::TestServer(uint port)
	: Server(port)
{
}

TestServer::~TestServer(void)
{
}

ServerConnection* TestServer::newServerConnection(XSocket* sock)
{
	return new TestServerConnection(sock, this);
}
