#include "Server.h"
#include "Client.h"

#include "XSocket.h"
#include "XServer.h"

#include <QtDebug>
#include <QThread>

#include "TestServer.h"



struct testData {
	int i;
	bool yes;
	QString someMsg;
};

QByteArray pack(const testData& data)
{
	QByteArray ar;
	QDataStream out(&ar, QIODevice::WriteOnly);
	out << data.i;
	out << data.yes;
	out << data.someMsg;
	
	return ar;
}

testData unpack(QByteArray data)
{
	testData out;
	QDataStream in(&data, QIODevice::ReadOnly);
	in >> out.i;
	in >> out.yes;
	in >> out.someMsg;
	return out;
}

void print(QString prefix, const testData& data)
{
	qDebug() << prefix << data.i << data.yes << data.someMsg;
}

testData randomData(QString msg)
{
	testData data;
	data.someMsg = msg;
	data.i = 123123123;
	data.yes = true;
	return data;
}

int main(int argc, char** argv)
{
	/*
	if( argc == 2 )
	{
		try {
			XSocket sock;
			sock.connect(argv[1], 3000);
			
			//sock.send("INIT {ClassName USARBot.P2AT} {Name Jimmy} {Location 0.4,2.1,1.8} {Rotation 0.0,0.0,0.0}\r\n");
			
			QByteArray line;
			for(int i=0; i<10; i++) {
				line = sock.receiveBytes(3000); // wait 3 seconds
				
				if(line.size() > 0)
					print("recieved", unpack(line));
					
				int sent = sock.sendBytes( pack( randomData("message from the client") ) );
				qDebug() << "sent " << sent << " bytes";
			}
			
			// sock destroyed as it runs out of scope
			
		} catch (Exception e) {
			qDebug() << "error: " << e.report();
		}
	}
	else
	{
		try {
			XServer serv;
			XSocket* conn = NULL;
			
			QString portStr(argv[2]);
			uint port = portStr.toUInt();
			
			serv.listen( port );
			
			qDebug() << "listeing on port " << port;
			while(true)
			{
				conn = serv.accept(3000); // wait at most 3 secs for a new connection
				if( conn != NULL ) // there was actually a connection
				{
					qDebug() << " connection!";
					try {
						
						QByteArray line;
						for(int i=0; i<20; i++) {
							line = conn->receiveBytes(30); // wait 3 seconds
							
							if( line.length() > 0 )
								print("received" , unpack(line));
							else
								qDebug() << "nothing to receive!";
							
							int sent = conn->sendBytes( pack( randomData("message from the server")));
							qDebug() << "sent " << sent << " bytes";
						}
						
					} catch (Exception e) {
						qDebug() << "sockerror: " << e.report();
					}
					delete conn;
				}
				else
				{
					qDebug() << "no connection.";
				}
			}
			
		} catch (Exception e) {
			qDebug() << "error: " << e.report();
		}
	}
	*/

	qDebug() << "argc=" << argc;

	try
	{
		if(argc == 1)
		{
			TestServer serv(3000);
			serv.wait();

			qDebug() << serv.isRunning();
		}
		else
		{
			Client cli("127.0.0.1",3000);
			cli.setQueueWhenDisconnected(true);
			
			cli.put("blah");
			
			cli.connect();

			QString t = cli.echo(argv[1]);

			qDebug() << "received: " << t;
		}
	} catch (Exception e) {
		qDebug() << e.report();
	}
	
	return 1;
}

