#ifndef MAPVIEW_H
#define MAPVIEW_H

#include <QtGui>

#include "ScanUtils.h"

class QPaintEvent;


class MapView : public QWidget
{
    Q_OBJECT


public:

    MapView(QWidget *parent = 0);

    QSize minimumSizeHint() const;
    QSize sizeHint() const;

    
    void addScan(ScanObservation &scan);



protected:

    void paintEvent(QPaintEvent* event);


private:

    QList<ScanObservation> scans;
    QImage buffer;

    void plotMap(QPainter& painter);
    void plotScan(QPainter& painter, ScanObservation& scan);
    void plotPose(QPainter& painter, Pose2D& pose);

};

#endif
