
#ifndef QTMANIFOLDRENDERER_H
#define QTMANIFOLDRENDERER_H

#include <QtGui>

#include "ScanUtils.h"
#include "ManifoldRenderer.h"

class QtManifoldRenderer : public ManifoldRenderer
{

protected:
    static const float MAPUNIT;
    static const float OFFSETX;
    static const float OFFSETY;

public:
    QtManifoldRenderer(QImage* image, Bounds bounds);
    virtual ~QtManifoldRenderer();

    virtual void renderScan(Pose2D scanPose, ScanObservation* scan, uint number = 0);
    virtual void renderLink(Pose2D firstPose, Pose2D secondPose);
    virtual void renderRFID(RFIDData rfid);
    virtual void renderScansRFIDs(Pose2D scanPose, ScanObservation* scan, uint number);
    void renderVictimRFID(VictimRFIDData rfid);

protected:

    QImage* image;
    
    QMatrix mapToImage;
    QPen freeAreaPen;
    QPen occupiedAreaPen;
    
    QPen posePen;
    QPen linkPen;
    
    QPen rfidPen;
    QPen victimPen;
    
    QPainter painter;

};

#endif /*QTMANIFOLDRENDERER_H*/
