#include "QtSimpleManifoldRenderer.h"

QtSimpleManifoldRenderer::QtSimpleManifoldRenderer(QImage* image, Bounds bounds)
: QtManifoldRenderer(image, bounds)
{
}

QtSimpleManifoldRenderer::~QtSimpleManifoldRenderer()
{
}

void QtSimpleManifoldRenderer::renderScan(Pose2D scanPose, ScanObservation* scan, uint number) {

    float a = 0;
	
	Vector2 vGlobal;

	Matrix3 rotmx;
    rotmx.setRotation(scanPose.rot);
    rotmx.setTranslation(scanPose.x, scanPose.y);
	
	QPoint  posePoint(scanPose.x, scanPose.y);
	QPoint* points   = new QPoint[scan->length];
	
	int increment =1;
	if( scan->length > 181 )
		increment = 2;
    for (uint i = 0; i < scan->length; i+=increment) {
        a = M_PI/(scan->length-1)*i - M_PI_2;
        vGlobal = rotmx.multiply( Vector2( scan->range[i] * cos(a), scan->range[i] * sin(a) ) );
		points[i]   = QPoint(vGlobal.x, vGlobal.y);
    }

	//painter.setPen(freeAreaPen);
	//painter.setBrush(QBrush(QColor(255,255,255,10)));
	//painter.drawPolygon(points, scan->length, Qt::OddEvenFill);

    painter.setPen(occupiedAreaPen);
    painter.drawPoints(points, scan->length);
}
