#include <QApplication>
#include <QtDebug>
#include <QFile>
#include <QString>
#include <QStringList>


#include <iostream>

#include "tclap/CmdLine.h"

#include "MainWindow.h"
#include "MainView.h"
#include "MapView.h"

#include "Exception.h"
#include "LaserData.h"
#include "LaserData3D.h"
#include "StatusData.h"

#include "ScanMatcher.h"
#include "WeightedScanMatcher.h"
#include "UnweightedScanMatcher.h"

#include "ScanPlayer.h"
#include "LogScanPlayer.h"
#include "LiveScanPlayer.h"


using namespace TCLAP;
using namespace std;

QString _logfile;

void parseOptions(int argc, char** argv);

int main(int argc, char* argv[]) {

    Q_INIT_RESOURCE(sm);

    QApplication app(argc, argv);

    // parseOptions(argc,argv);

    MainWindow mainWin;
    mainWin.show();

    int result = app.exec();
    return result;
}





void parseOptions(int argc, char** argv)
{
	try {
    	CmdLine cmd("Command line options for scanmatcher.", ' ', "0.1" );

	    // Define arguments
	    ValueArg<string> logfile("l", "log", "logfile", false, "log.dat", "string");
	    cmd.add(logfile);

        /*
	    ValueArg<string> rotation("r", "spawn_rotation", "the spawn rotation of the robot (Default: in x direction)", false, "0.0,0.0,0.0", "string");
	    cmd.add(rotation);
	    ValueArg<string> position("s", "spawn_position", "the spawn position of the robot (Default: start in orange arena)", false, "0.4,2.1,1.8", "string");
	    cmd.add(position);
	    ValueArg<string> name("n", "name", "a friendly name for the robot, (Default: Jimmy)", false, "Jimmy", "string");
	    cmd.add(name);
	    ValueArg<string> model("m", "model", "the type of robot to spawn, (Default: P2AT)", false, "USARBot.P2AT", "string");
	    cmd.add(model);
	    ValueArg<int> port("p", "port",  "the port to connect to (Default: 3000)", false, 3000, "int");
	    cmd.add(port);
	    UnlabeledValueArg<string> host("host", "the host to connect to (Default: localhost)", "localhost", "string");
	    cmd.add(host);
        //*/

	    // Parse the command line.
	    cmd.parse(argc, argv);

	    // Retrieve variables
        _logfile  = _logfile.fromStdString(logfile.getValue());

	} 
    catch (ArgException& e)
	{
        QString err = err.fromStdString("ERROR: " + e.error() + " " + e.argId());
        qDebug() << err;
    }
    //*/
}
